as={}
-----------------------------
-- Ally System v5 by mat5b --
-----------------------------

as.lang=0
as.idtable={1,2,3,4,5,6,7,8,9,10}
as.chatstring="`"

function array(d,c)
	local tab={}
	for i=1,d do
		tab[i]=c
	end
	return tab
end
function translate(id,word)
	local n=0
	for i=1,#as.english do
		if as.english[i]==word then
			n=i
		end
	end
	if as.language[id]=="English" then
		return word
	elseif as.language[id]=="German" then
		return as.german[n]
	elseif as.language[id]=="Polish" then
		return as.polish[n]
	elseif as.language[id]=="Russian" then
		return word
	end
	return word
end

as.ally={}
as.nemesis={}
as.ally.person=array(32,0)
as.page=array(32,0)
as.context=array(32,0)
as.placeh=array(32,0)
as.ally.image=array(32,0)
as.popup={}
as.popup.image=array(32,{})
as.popup.text=array(32,{})
as.popup.queue=array(32,{})
as.nemesis.person=array(32,0)
as.nemesis.image=array(32,0)
as.nemesis.count=array(32,array(32,0))
as.nemesis.deaths=array(32,0)
--as.team={}
--as.team.self=array(32,{})
as.ally.teamwork=array(32,0)
as.language=array(32,"English")
as.busy=array(32,0)
as.funnydeaths={"slayed","spillt_soda_on","slapped","steamrolled","farted_towards","coughed_at"}
as.english={"Next","Previous","Back","Ally Menu","Invite ally","Remove ally","Teleport","Trade items","Give health","Give money","Trade armor","Toggle Merging","Rage Menu","RageKill","Track him down!","RagePlode","Team Menu","Create Team","Remove Team","Invite players","Kick players","Merge whole team","You already have an ally!","This player does not exist anymore!","Player List Page","Trading Weapons (Ally) Page","Trading Weapons (You) Page"}
as.polish={"Nastepne","Poprzednie","Wroc","Ally Menu","Invite ally","Remove ally","Teleport","Trade items","Give health","Give money","Trade armor","Toggle Merging","Rage Menu","RageKill","Track him down!","RagePlode","Team Menu","Create Team","Remove Team","Invite players","Kick players","Merge whole team","You already have an ally!","This player does not exist anymore!","Player List Page","Trading Weapons (Ally) Page","Trading Weapons (You) Page"}
as.german={"Naechste","Vohrige","Zuruck","Ally Menu","Invite ally","Remove ally","Teleport","Trade items","Give health","Give money","Trade armor","Toggle Merging","Rage Menu","RageKill","Track him down!","RagePlode","Team Menu","Create Team","Remove Team","Invite players","Kick players","Merge whole team","You already have an ally!","This player does not exist anymore!","Player List Page","Trading Weapons (Ally) Page","Trading Weapons (You) Page"}
as.russian={"Next","Previous","Back","Ally Menu","Invite ally","Remove ally","Teleport","Trade items","Give health","Give money","Trade armor","Toggle Merging","Rage Menu","RageKill","Track him down!","RagePlode","Team Menu","Create Team","Remove Team","Invite players","Kick players","Merge whole team","You already have an ally!","This player does not exist anymore!","Player List Page","Trading Weapons (Ally) Page","Trading Weapons (You) Page"}
as.popups={}
as.popups.sizes={{7,4},{7,4},{7,3},{7,3}}
as.popups.ids={}
as.popups.coords={{590,280},{590,280},{600,290},{600,290}}
as.popups.contents={{"wants to trade his",10,540,10,240,"armor (AP)",10,555,10,255,"for your",10,570,10,270,"armor ( AP)!",10,585,10,285,"F2 - Accept",10,600,10,300,"F3 - Deny",10,620,10,320},
					{"wants to trade his",10,540,10,240,"wepon",10,555,10,255,"for your",10,570,10,270,"other wepon",10,585,10,285,"F2 - Accept",10,600,10,300,"F3 - Deny",10,620,10,320},
					{"wants to be your ally!",10,570,10,270,"F2 - Accept",10,590,10,290,"F3 - Deny",10,610,10,310},
					{"wants to merge with you!",10,570,10,270,"F2 - Accept",10,590,10,290,"F3 - Deny",10,610,10,310}}
as.popups.subcontents={{10,525,10,225},{10,525,10,225},{10,555,10,255},{10,555,10,255}}
as.popups.colors={ {{255,255,255},{255,255,255},{255,255,255},{255,255,255},{0,125,0},{125,0,0}} , {{255,255,255},{255,255,255},{255,255,255},{255,255,255},{0,125,0},{125,0,0}} , {{255,255,255},{0,125,0},{125,0,0}} , {{255,255,255},{0,125,0},{125,0,0}}}

addhook("serveraction","as.serveraction")
function as.serveraction(id,a)
	if tonumber(id)==nil then
		for i=1,string.len(id) do
			if string.sub(id,i,i)=="," then
				a=tonumber(string.sub(id,i+1))
				id=tonumber(string.sub(id,1,i-1))
			end
		end
	end
	if player(id,"team")>0 then
		if #as.popup.image[id]==0 then
			if a==1 then
				if as.ally.person[id]~=0 then
					menu(id,translate(id,"Ally Menu")..","..translate(id,"Invite ally")..","..translate(id,"Remove ally")..","..translate(id,"Teleport")..","..translate(id,"Trade items")..","..translate(id,"Give health")..","..translate(id,"Give money")..","..translate(id,"Trade armor")..","..translate(id,"Toggle Merging"))
				else
					menu(id,translate(id,"Ally Menu")..","..translate(id,"Invite ally").."")
				end
			elseif a==2 then
				if as.nemesis.person[id]~=0 then
					local t={"Ready to deploy!","Ready to deploy!"}
					if as.nemesis.deaths[id]<3 then
						t[1]=3-as.nemesis.deaths[id].." deaths to go"
						t[2]=5-as.nemesis.deaths[id].." deaths to go"
					elseif as.nemesis.deaths[id]<5 then
						t[2]=5-as.nemesis.deaths[id].." deaths to go"
					end
					menu(id,translate(id,"Rage Menu")..","..translate(id,"RageKill").." | "..t[1]..","..translate(id,"Track him down!")..","..translate(id,"RagePlode").." | "..t[2].."")
				else
					msg2(id,"255000000You don't have a nemesis!")
				end
			--else
				--menu(id,"Client Settings,Change Language")--,Change Popup Base Color,Change Popup Side Color,Change Button Color")
			end
		else
			if as.popup.text[id][2]=="wants to be your ally!" then
				if a==1 then
					if as.ally.person[id]==0 then
						as.ally.person[id]=as.popup.text[id][1]
						as.ally.person[as.popup.text[id][1]]=id
						msg2(id,"000155000You and "..player(as.ally.person[id],"name").." are now allies!")
						msg2(as.ally.person[id],"000175000You and "..player(id,"name").." are now allies!")
						as.ally.image[as.ally.person[id]]=image("gfx/hud/ally.png",0,0,200+id,as.ally.person[id])
						as.ally.image[id]=image("gfx/hud/ally.png",0,0,200+as.ally.person[id],id)
						freeimage(as.popup.image[id][1])
						freeimage(as.popup.image[id][2])
						parse("hudtxt2 "..id.." "..as.idtable[1].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[2].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[3].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[4].." \"\" 0 0 0")
						as.popup.image[id]={}
						as.popup.text[id]={}
						as.busy[as.ally.person[id]]=0
						as.popup.queuefree(id)
					else
						msg2(id,"175000000You already have an ally!")
					end
				elseif a==2 then
					if as.ally.person[id]==0 then
						msg2(as.popup.text[id][1],"175000000"..player(id,"name").." has denied your request.")
						freeimage(as.popup.image[id][1])
						freeimage(as.popup.image[id][2])
						as.busy[as.popup.text[id][1]]=0
						parse("hudtxt2 "..id.." "..as.idtable[1].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[2].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[3].." \"\" 0 0 0")
						parse("hudtxt2 "..id.." "..as.idtable[4].." \"\" 0 0 0")
						as.popup.image[id]={}
						as.popup.text[id]={}
						as.popup.queuefree(id)
					else
						msg2(id,"175000000You already have an ally!")
					end
				end
			elseif as.popup.text[id][2]=="trading" then
				if a==1 then
					parse("equip "..id.." "..as.popup.text[id][4].."")
					parse("setweapon "..id.." "..as.popup.text[id][4].."")
					parse("equip "..as.ally.person[id].." "..as.popup.text[id][3].."")
					parse("setweapon "..as.ally.person[id].." "..as.popup.text[id][3].."")
					parse("strip "..id.." "..as.popup.text[id][3].."")
					parse("strip "..as.ally.person[id].." "..as.popup.text[id][4].."")
					msg2(id,"000175000The trade has been succesfully fullfilled!")
					msg2(as.ally.person[id],"000175000The trade has been succesfully fullfilled!")
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				elseif a==2 then
					msg2(as.ally.person[id],"175000000"..player(id,"name").." has denied your request.")
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				end
			elseif as.popup.text[id][2]=="armor" then
				if a==1 then
					local a1=player(id,"armor")
					local a2=player(as.ally.person[id],"armor")
					parse("setarmor "..id.." "..a2.."")
					parse("setarmor "..as.ally.person[id].." "..a1.."")
					msg2(id,"000175000The trade has been succesfully fullfilled!")
					msg2(as.ally.person[id],"000175000The trade has been succesfully fullfilled!")
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				elseif a==2 then
					msg2(as.ally.person[id],"175000000"..player(id,"name").." has denied your request.")
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				end
			elseif as.popup.text[id][2]=="teamwork" then
				if a==1 then
					msg2(id,"000175000You are now moving together at the same time!")
					msg2(as.ally.person[id],"000175000You are now moving together at the same time!")
					sethookstate("move",1)
					as.ally.teamwork[id]=1
					as.ally.teamwork[as.ally.person[id]]=1
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				elseif a==2 then
					msg2(as.ally.person[id],"175000000"..player(id,"name").." has denied your request.")
					freeimage(as.popup.image[id][1])
					freeimage(as.popup.image[id][2])
					for g=1,7 do
						parse("hudtxt2 "..id.." "..as.idtable[g].." \"\" 0 0 0")
					end
					as.popup.image[id]={}
					as.popup.text[id]={}
					as.busy[as.ally.person[id]]=0
					as.popup.queuefree(id)
				end
			end
		end
	end
end

function as.popup.queuefree(id)
	freetimer("as.serveraction",""..id..",2")
	if #as.popup.queue[id]<=1 then
		parse("hudtxt2 "..id.." "..as.idtable[8].." \"\" 0 0 0")
	else
		if #as.popup.queue[sel]>1 then
			parse('hudtxt2 '..id..' '..as.idtable[8]..' "'..#as.popup.queue[sel]..' popups waiting" 10 430 0')
		else
			parse('hudtxt2 '..id..' '..as.idtable[8]..' "1 popup waiting" 10 430 0')
		end
		parse("hudtxtcolorfade "..id.." "..as.idtable[8].." 100 255 255 255")
	end
	if #as.popup.queue[id]>=1 then
		if as.popup.queue[id][1][1]==1 then
			as.popup.pop(id,3,as.popup.queue[id][1][2],0)
			table.remove(as.popup.queue[id],1)
		elseif as.popup.queue[id][1][1]==2 then
			as.popup.pop(id,2,as.ally.person[id],0,as.popup.queue[1][3])
			table.remove(as.popup.queue[id],1)
		elseif as.popup.queue[id][1][1]==3 then
			as.popup.pop(id,1,as.ally.person[id],0)
			table.remove(as.popup.queue[id],1)
		elseif as.popup.queue[id][1][1]==4 then
			as.popup.pop(id,4,as.ally.person[id],0)
			table.remove(as.popup.queue[id],1)
		end
	end
end

function as.popup.pop(id,t,p,d,a)
	if #as.popup.image[id]==0 or d==0 then
		as.popup.image[id]={image("gfx/hud/square_trans.png",50,as.popups.coords[t][1],2,id),image("gfx/hud/overl_full.png",50,as.popups.coords[t][1],2,id)}
		imagescale(as.popup.image[id][1],as.popups.sizes[t][1],as.popups.sizes[t][2])
		tween_move(as.popup.image[id][1],500,50,as.popups.coords[t][2])
		imagecolor(as.popup.image[id][2],0,0,0)
		imagescale(as.popup.image[id][2],as.popups.sizes[t][1],as.popups.sizes[t][2])
		tween_move(as.popup.image[id][2],500,50,as.popups.coords[t][2])
		if t==1 then
			as.popup.text[id]={p,"armor"}
		elseif t==2 then
			as.popup.text[id]={p,"trading",as.placeh[p],playerweapons(p)[a]}
		elseif t==3 then
			as.popup.text[id]={p,"wants to be your ally!"}
		elseif t==4 then
			as.popup.text[id]={p,"teamwork"}
		end
		parse('hudtxt2 '..id..' '..as.idtable[1]..' "'..player(p,"name")..'" '..as.popups.subcontents[t][1]..' '..as.popups.subcontents[t][2]..' 0')
		parse("hudtxtcolorfade "..id.." "..as.idtable[1].." 100 255 255 255")
		parse("hudtxtmove "..id.." "..as.idtable[1].." 500 "..as.popups.subcontents[t][3].." "..as.popups.subcontents[t][4].."")
		local i=0
		local s=""
		for c=1,#as.popups.contents[t]/5 do
			i=(c*5)-4
			if t==1 then
				if c==2 then
					s="armor ("..player(p,"armor").." AP)"
				elseif c==4 then
					s="armor ("..player(id,"armor").." AP)"
				else
					s=as.popups.contents[t][i]
				end
			elseif t==2 then
				if c==4 then
					s=itemtype(as.placeh[p],"name")
				elseif c==2 then
					s=itemtype(playerweapons(p)[a],"name")
				else
					s=as.popups.contents[t][i]
				end
			else
				s=as.popups.contents[t][i]
			end
			parse('hudtxt2 '..id..' '..as.idtable[c+1]..' "'..s..'" '..as.popups.contents[t][i+1]..' '..as.popups.contents[t][i+2]..' 0')
			parse("hudtxtcolorfade "..id.." "..as.idtable[c+1].." 100 "..as.popups.colors[t][c][1].." "..as.popups.colors[t][c][2].." "..as.popups.colors[t][c][3].."")
			parse("hudtxtmove "..id.." "..as.idtable[c+1].." 500 "..as.popups.contents[t][i+3].." "..as.popups.contents[t][i+4].."")
		end
		as.busy[p]=1
		parse("sv_sound2 "..id.." \"hud/popup.ogg\"")
		timer(10000,"as.serveraction",""..id..",2")
	else
		as.busy[id]=1
		if t==1 then
			table.insert(as.popup.queue[id],{3,"armor"})
		elseif t==2 then
			table.insert(as.popup.queue[id],{2,as.placeh[p],a})
		elseif t==3 then
			table.insert(as.popup.queue[id],{1,p})
		elseif t==4 then
			table.insert(as.popup.queue[id],{4,as.ally.person[p]})
		end
		if #as.popup.queue[id]>1 then
			parse('hudtxt2 '..id..' '..as.idtable[8]..' "'..#as.popup.queue[id]..' popups waiting" 10 430 0')
		else
			parse('hudtxt2 '..id..' '..as.idtable[8]..' "1 popup waiting" 10 430 0')
		end
		parse("hudtxtcolorfade "..id.." "..as.idtable[8].." 100 255 255 255")
	end
end

if as.lang==1 then
	addhook("team","as.team")
end

function as.team(id,t)
	if t>0 then
		menu(id,"Choose your language,English,Polski,Deutsch")
	end -- Since I know you like bonus points, here's something: http://dl.dropbox.com/u/12151154/Houses%20RPG/servertransfer.lst
end

addhook("menu","as.menu")
function as.menu(id,men,sel)
	if men==translate(id,"Ally Menu") then
		if sel==1 then
			if as.busy[id]==0 then
				if as.ally.person[id]==0 then
					as.page[id]=1
					as.context[id]=1
					local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
					for i=1,7 do
						if player(i,"exists") and i~=id and player(i,"team")>0 then
							t[i]=player(i,"name")
						else
							t[i]=""
						end
					end
					menu(id,translate(id,"Player List Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
				else
					msg2(id,"155000000"..translate(id,"You already have an ally!"))
				end
			else
				msg2(id,"155000000You are already requesting something!")
			end
		elseif sel==2 then
			as.ally.person[as.ally.person[id]]=0
			freeimage(as.ally.image[as.ally.person[id]])
			freeimage(as.ally.image[id])
			as.ally.image[id]=0
			as.ally.image[as.ally.person[id]]=0
			msg2(as.ally.person[id],"175000000"..player(id,"name").." has stopped being your ally!")
			msg2(id,"175000000You stopped being "..player(as.ally.person[id],"name").."'s ally!")
			as.ally.person[id]=0
		elseif sel==3 then
			parse("setpos "..id.." "..player(as.ally.person[id],"x").." "..player(as.ally.person[id],"y").."")
		elseif sel==4 then
			as.page[id]=1
			local p=as.ally.person[id]
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(p)[i]~=nil then
					if playerweapons(p)[i]~=50 then
						t[i]=itemtype(playerweapons(p)[i],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(p)[8]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==5 then
			menu(id,"Give health,10 HP,20 HP,50 HP,100 HP,Max. HP,"..translate(id,"Back").."")
		elseif sel==6 then
			menu(id,"Give money,100$,500$,1000$,2000$,5000$,10000$,16000$,"..translate(id,"Back").."")
		elseif sel==7 then
			local p=as.ally.person[id]
			as.popup.pop(p,1,id,1)
			msg2(id,"000155000The request has been sent.")
		elseif sel==8 then
			if as.ally.teamwork[id]==0 then
				as.popup.pop(as.ally.person[id],4,id,1)
				msg2(id,"000155000The request has been sent.")
			else
				as.ally.teamwork[id]=0
				as.ally.teamwork[as.ally.person[id]]=0
				msg2(as.ally.person[id],"175000000"..player(id,"name").." stopped moving along with you!")
				msg2(id,"175000000You stopped moving along with "..player(as.ally.person[id],"name").."!")
				local c=0
				for id=1,#player(0,"table") do
					if as.ally.teamwork[player(0,"table")[id]]==1 then
						c=1
					end
				end
				if c==0 then
					sethookstate("move",0)
				end
			end
		end
	elseif men=="Give health" then
		if sel==1 then
			if player(id,"health")>10 then
				if player(as.ally.person[id],"health")<=player(as.ally.person[id],"maxhealth")-10 then
					parse("sethealth "..id.." "..player(id,"health")-10)
					parse("sethealth "..as.ally.person[id].." "..player(as.ally.person[id],"health")+10)
					msg2(as.ally.person[id],"000175000Your ally gave you 10 HP!")
				else
					msg2(id,"175000000Your ally has maximum health!")
				end
			else
				msg2(id,"175000000You don't have enough health!")
			end
		elseif sel==2 then
			if player(id,"health")>20 then
				if player(as.ally.person[id],"health")<=player(as.ally.person[id],"maxhealth")-20 then
					parse("sethealth "..id.." "..player(id,"health")-20)
					parse("sethealth "..as.ally.person[id].." "..player(as.ally.person[id],"health")+20)
					msg2(as.ally.person[id],"000175000Your ally gave you 20 HP!")
				else
					msg2(id,"175000000Your ally has maximum health!")
				end
			else
				msg2(id,"175000000You don't have enough health!")
			end
		elseif sel==3 then
			if player(id,"health")>50 then
				if player(as.ally.person[id],"health")<=player(as.ally.person[id],"maxhealth")-50 then
					parse("sethealth "..id.." "..player(id,"health")-50)
					parse("sethealth "..as.ally.person[id].." "..player(as.ally.person[id],"health")+50)
					msg2(as.ally.person[id],"000175000Your ally gave you 50 HP!")
				else
					msg2(id,"175000000Your ally has maximum health!")
				end
			else
				msg2(id,"175000000You don't have enough health!")
			end
		elseif sel==4 then
			if player(id,"health")>100 then
				if player(as.ally.person[id],"health")<=player(as.ally.person[id],"maxhealth")-100 then
					parse("sethealth "..id.." "..player(id,"health")-100)
					parse("sethealth "..as.ally.person[id].." "..player(as.ally.person[id],"health")+100)
					msg2(as.ally.person[id],"000175000Your ally gave you 10 HP!")
				else
					msg2(id,"175000000Your ally has maximum health!")
				end
			else
				msg2(id,"175000000You don't have enough health!")
			end
		elseif sel==5 then
			if player(id,"health")<player(id,"maxhealth") then
				if player(as.ally.person[id],"health")<=player(as.ally.person[id],"maxhealth")-(player(id,"maxhealth")-player(id,"health")) then
					parse("sethealth "..id.." "..player(id,"health")-(player(id,"maxhealth")-player(id,"health")))
					parse("sethealth "..as.ally.person[id].." "..player(as.ally.person[id],"health")+(player(id,"maxhealth")-player(id,"health")))
					msg2(as.ally.person[id],"000175000Your ally gave you "..player(id,"maxhealth")-player(id,"health").." HP!")
				else
					msg2(id,"175000000Your ally has maximum health!")
				end
			else
				msg2(id,"175000000You don't have enough health!")
			end
		elseif sel==6 then
			as.serveraction(id,1)
		end
	elseif men=="Give money" then
		if sel==1 then
			if player(id,"money")>=100 then
				if player(as.ally.person[id],"money")<=15900 then
					parse("setmoney "..id.." "..player(id,"money")-100)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+100)
					msg2(as.ally.person[id],"000175000Your ally gave you 100$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==2 then
			if player(id,"money")>=500 then
				if player(as.ally.person[id],"money")<=15500 then
					parse("setmoney "..id.." "..player(id,"money")-500)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+500)
					msg2(as.ally.person[id],"000175000Your ally gave you 500$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==3 then
			if player(id,"money")>=1000 then
				if player(as.ally.person[id],"money")<=15000 then
					parse("setmoney "..id.." "..player(id,"money")-1000)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+1000)
					msg2(as.ally.person[id],"000175000Your ally gave you 1000$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==4 then
			if player(id,"money")>=2000 then
				if player(as.ally.person[id],"money")<=14000 then
					parse("setmoney "..id.." "..player(id,"money")-2000)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+2000)
					msg2(as.ally.person[id],"000175000Your ally gave you 2000$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==5 then
			if player(id,"money")>=5000 then
				if player(as.ally.person[id],"money")<=11000 then
					parse("setmoney "..id.." "..player(id,"money")-5000)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+5000)
					msg2(as.ally.person[id],"000175000Your ally gave you 5000$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==6 then
			if player(id,"money")>=10000 then
				if player(as.ally.person[id],"money")<=6000 then
					parse("setmoney "..id.." "..player(id,"money")-10000)
					parse("setmoney "..as.ally.person[id].." "..player(as.ally.person[id],"money")+10000)
					msg2(as.ally.person[id],"000175000Your ally gave you 10000$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==7 then
			if player(id,"money")>=16000 then
				if player(as.ally.person[id],"money")==0 then
					parse("setmoney "..id.." "..player(id,"money")-16000)
					parse("setmoney "..as.ally.person[id].." 16000")
					msg2(as.ally.person[id],"000175000Your ally gave you 16000$!")
				else
					msg2(id,"175000000Your ally has maximum money!")
				end
			else
				msg2(id,"175000000You don't have enough money!")
			end
		elseif sel==8 then
			as.serveraction(id,1)
		end
	elseif men==translate(id,"Trading Weapons (You) Page").." 1" then
		if sel>=1 and sel<=7 then
			local p=as.ally.person[id]
			as.popup.pop(p,2,id,1,sel)
			msg2(id,"000155000The request has been sent.")
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+(7*(as.page[id]-2))
			for i=1,7 do
				if playerweapons(id)[i+pos]~=nil then
					if playerweapons(id)[i+pos]~=as.placeh[id] then
						t[i]=itemtype(playerweapons(id)[i+pos],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(id)[pos+7]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			as.page[id]=1
			local p=as.ally.person[id]
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(p)[i]~=nil then
					if playerweapons(p)[i]~=50 then
						t[i]=itemtype(playerweapons(p)[i],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(p)[8]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		end
	elseif men==translate(id,"Trading Weapons (You) Page").." "..as.page[id].."" then
		if sel>=1 and sel<=7 then
			local pos=7+(7*(as.page[id]-2))
			local p=as.ally.person[id]
			as.popup.pop(p,2,id,1,sel+pos)
			msg2(id,"000155000The request has been sent.")
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+(7*(as.page[id]-2))
			for i=1,7 do
				if playerweapons(id)[i+pos]~=nil then
					if playerweapons(id)[i+pos]~=as.placeh[id] then
						t[i]=itemtype(playerweapons(id)[i+pos],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(id)[pos+8]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			as.page[id]=as.page[id]-1
			if as.page[id]~=1 then
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
				local pos=7+(7*(as.page[id]-2))
				for i=1,7 do
					if playerweapons(id)[i+pos]~=nil then
						if playerweapons(id)[i+pos]~=as.placeh[id] then
							t[i]=itemtype(playerweapons(id)[i+pos],"name")
						else
							t[i]=""
						end
					else
						t[8]=""
						break
					end
				end
				if playerweapons(id)[pos+8]==nil then
					t[8]=""
				end
				menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			else
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
				for i=1,7 do
					if playerweapons(id)[i]~=nil then
						if playerweapons(id)[i]~=50 and playerweapons(id)[i]~=as.placeh[id] then
							t[i]=itemtype(playerweapons(id)[i],"name")
						else
							t[i]=""
						end
					else
						t[8]=""
						break
					end
				end
				if playerweapons(id)[8]==nil then
					t[8]=""
				end
				menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			end
		end
	elseif men==translate(id,"Trading Weapons (Ally) Page").." 1" then
		if sel>=1 and sel<=7 then
			as.placeh[id]=playerweapons(as.ally.person[id])[sel]
			as.page[id]=1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(id)[i]~=nil then
					if playerweapons(id)[i]~=50 and playerweapons(id)[i]~=as.placeh[id] then
						t[i]=itemtype(playerweapons(id)[i],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(id)[8]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local pos=7+(7*(as.page[id]-2))
			local p=as.ally.person[id]
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(p)[i+pos]~=nil then
					t[i+pos]=itemtype(playerweapons(p)[i+pos],"name")
				else
					t[8]=""
				end
			end
			if playerweapons(p)[pos+7]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			as.serveraction(id,1)
		else
			as.placeh[id]=0
		end
	elseif men==translate(id,"Trading Weapons (Ally) Page").." "..as.page[id].."" then
		if sel>=1 and sel<=7 then
			local pos=7+(7*(as.page[id]-2))
			as.placeh[id]=playerweapons(as.ally.person[id])[sel+pos]
			as.page[id]=1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(id)[i]~=nil then
					if playerweapons(id)[i]~=50 and playerweapons(id)[i]~=playerweapons(as.ally.person[id])[sel+pos] then
						t[i]=itemtype(playerweapons(id)[i],"name")
					else
						t[i]=""
					end
				else
					t[8]=""
					break
				end
			end
			if playerweapons(id)[8]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (You) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local pos=7+(7*(as.page[id]-2))
			local p=as.ally.person[id]
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
			for i=1,7 do
				if playerweapons(p)[i+pos]~=nil then
					t[i+pos]=itemtype(playerweapons(p)[i+pos],"name")
				else
					t[8]=""
				end
			end
			if playerweapons(p)[pos+7]==nil then
				t[8]=""
			end
			menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			as.page[id]=as.page[id]-1
			if as.page[id]~=1 then
				local pos=7+(7*(as.page[id]-2))
				local p=as.ally.person[id]
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
				for i=1,7 do
					if playerweapons(p)[i+pos]~=nil then
						t[i+pos]=itemtype(playerweapons(p)[i+pos],"name")
					else
						t[8]=""
					end
				end
				if playerweapons(p)[pos+7]==nil then
					t[8]=""
				end
				menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			else
				local p=as.ally.person[id]
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
				for i=1,7 do
					if playerweapons(p)[i]~=nil then
						if playerweapons(p)[i]~=50 then
							t[i]=itemtype(playerweapons(p)[i],"name")
						else
							t[i]=""
						end
					else
						t[8]=""
						break
					end
				end
				if playerweapons(p)[7]==nil then
					t[8]=""
				end
				menu(id,translate(id,"Trading Weapons (Ally) Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			end
		else
			as.placeh[id]=0
		end
	elseif men==translate(id,"Player List Page").." 1" then
		if sel>=1 and sel<=7 then
			if as.context[id]==1 then
				if as.ally.person[sel]==0 then
					if as.nemesis.person[id]~=sel then
						if player(sel,"exists") then
							as.popup.pop(sel,3,id,1)
							msg2(id,"000155000The request has been sent.")
						else
							msg2(id,"155000000"..translate(id,"This player does not exist anymore!"))
						end
					else
						msg2(id,"155000000This player is your nemesis!")
					end
				else
					msg2(id,"155000000This player already has an ally!")
				end
			else
			end
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+(7*(as.page[id]-2))
			for i=1,7 do
				if player(i+pos,"exists") and i+pos~=id and player(i+pos,"team")>0 then
					t[i]=player(i+pos,"name")
				else
					t[i]=""
				end
			end
			menu(id,translate(id,"Player List Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			as.serveraction(id,1)
		end
	elseif men==translate(id,"Player List Page").." "..as.page[id].."" then
		if sel>=1 and sel<=7 then
			local pos=7+(7*(as.page[id]-2))
			if as.context[id]==1 then
				if as.ally.person[sel+pos]==0 then
					if as.nemesis.person[id]~=sel+pos then
						if player(sel+pos,"exists") then
							as.popup.pop(sel+pos,3,id,1)
							msg2(id,"000155000The request has been sent.")
						else
							msg2(id,"155000000"..translate(id,"This player does not exist anymore!"))
						end
					else
						msg2(id,"155000000This player is your nemesis!")
					end
				else
					msg2(id,"155000000This player already has an ally!")
				end
			else
			end
		elseif sel==8 then
			as.page[id]=as.page[id]+1
			local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+(7*(as.page[id]-2))
			for i=1,7 do
				if player(i+pos,"exists") and i+pos~=id and player(i+pos,"team")>0 then
					t[i]=player(i+pos,"name")
				else
					t[i]=""
				end
			end
			if as.page[id]==4 then
				t[8]=""
			end
			menu(id,translate(id,"Player List Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
		elseif sel==9 then
			if as.page[id]~=1 then
				as.page[id]=as.page[id]-1
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
				local pos=7+(7*(as.page[id]-2))
				for i=1,7 do
					if player(i+pos,"exists") and i+pos~=id and player(i+pos,"team")>0 then
						t[i]=player(i+pos,"name")
					else
						t[i]=""
					end
				end
				menu(id,translate(id,"Player List Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			else
				as.page[id]=1
				local t={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
				for i=1,7 do
					if player(i,"exists") and i~=id and player(i,"team")>0 then
						t[i]=player(i,"name")
					else
						t[i]=""
					end
				end
				menu(id,translate(id,"Player List Page").." "..as.page[id]..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9])
			end
		end
	elseif men==translate(id,"Rage Menu") then
		if sel==1 then
			if as.nemesis.deaths[id]>=3 then
				as.nemesis.deaths[id]=as.nemesis.deaths[id]-3
				msg2(as.nemesis.person[id],"155000000You have been RAGEKILLED by "..player(id,"name").."!")
				parse("customkill "..id.." "..as.funnydeaths[math.random(1,#as.funnydeaths)].." "..as.nemesis.person[id].."")
			else
				msg2(id,"155000000You haven't died enough to your nemesis in order to use this!")
			end
		elseif sel==2 then
			if player(as.nemesis.person[id],"x")<=player(id,"x") and player(as.nemesis.person[id],"y")<=player(id,"y") then
				msg2(id,"000155000Your nemesis is north-west from your position!")
			elseif player(as.nemesis.person[id],"x")<player(id,"x") and player(as.nemesis.person[id],"y")>player(id,"y") then
				msg2(id,"000155000Your nemesis is south-west from your position!")
			elseif player(as.nemesis.person[id],"x")>player(id,"x") and player(as.nemesis.person[id],"y")>player(id,"y") then
				msg2(id,"000155000Your nemesis is south-east from your position!")
			elseif player(as.nemesis.person[id],"x")>player(id,"x") and player(as.nemesis.person[id],"y")<player(id,"y") then
				msg2(id,"000155000Your nemesis is north-east from your position!")
			end
		elseif sel==3 then
			if as.nemesis.deaths[id]>=5 then
				as.nemesis.deaths[id]=as.nemesis.deaths[id]-5
				msg2(as.nemesis.person[id],"155000000You have been RAGEPLODED by "..player(id,"name").."!")
				parse("explosion "..player(as.nemesis.person[id],"x").." "..player(as.nemesis.person[id],"y").." 1 999 "..id.."")
			else
				msg2(id,"155000000You haven't died enough to your nemesis in order to use this!")
			end
		elseif sel==9 then
			as.team(id,1)
		end
	elseif men=="Client Settings" then
		if sel==1 then
			as.team(id,1)
		end
	--elseif men==translate(id,"Team Menu") then
	elseif men=="Choose your language" then
		if sel==1 then
			as.language[id]="English"
		elseif sel==2 then
			as.language[id]="Polish"
		elseif sel==3 then
			as.language[id]="German"
		end
	end
end

addhook("hit","as.hit")
function as.hit(id,s)
	if s~=id and id==as.ally.person[s] then
		return 1
	end
end

addhook("die","as.die")
function as.die(id,k)
	if k~=0 then
		if as.nemesis.person[id]==0 then
			if as.nemesis.count[id][k]==0 then
				as.nemesis.count[id]=array(32,0)
			end
			as.nemesis.count[id][k]=as.nemesis.count[id][k]+1
			if as.nemesis.count[id][k]==3 then
				as.nemesis.person[id]=k
				as.nemesis.count[id]=array(32,0)
				as.nemesis.deaths[id]=3
				msg2(id,"175000000"..player(k,"name").." is your new nemesis!")
				msg2(id,"175000000Take revenge on him by using the Rage Menu!")
			end
		else
			if as.nemesis.person[id]==k then
				as.nemesis.deaths[id]=as.nemesis.deaths[id]+1
				if as.nemesis.deaths[id]==5 and as.nemesis.image[id]==0 then
					as.nemesis.image[id]=image("gfx/hud/nemesis.png",0,0,200+k,id)
				end
			end
		end
	end
end

addhook("kill","as.kill")
function as.kill(id,v)
	if id~=0 and v==as.nemesis.person[id] then
		if as.nemesis.image[id]~=0 then
			freeimage(as.nemesis.image[id])
			as.nemesis.image[id]=0
		end
		as.nemesis.person[id]=0
		as.nemesis.deaths[id]=0
		as.nemesis.count[id]=array(32,0)
		msg2(id,"000175000You took revenge on "..player(v,"name").."! Well done!")
	end   																												-- Good job getting this far, future starter!
end																														-- That said, have you found all the clues so far?
																														-- You pretty much need them for the rest of this.
addhook("leave","as.leave")																								-- Or at least have them opened in a seperate tab.
function as.leave(id)																									-- Because this next bit is a bit tricky.
	if as.ally.person[id]~=0 then																						-- The next clues have been cut because of the low budget. The only things left are 3 buckets of milk, 3 wheat, two sugar piles, and one egg.
		local p=as.ally.person[id]																						-- Look for more of them here: Script with Big Trees, Line (string.len(the_safe) * 10) + (#as.nemesis.image / 2)
		if as.ally.teamwork[id]~=0 then
			as.ally.teamwork[id]=0
			as.ally.teamwork[p]=0
			local c=0
			for id=1,#player(0,"table") do
				if as.ally.teamwork[player(0,"table")[id]]==1 then
					c=1
				end
			end
			if c==0 then
				sethookstate("move",0)
			end
		end
		as.ally.person[as.ally.person[id]]=0
		freeimage(as.ally.image[as.ally.person[id]])
		freeimage(as.ally.image[id])
		as.ally.image[id]=0
		as.ally.image[as.ally.person[id]]=0
		msg2(as.ally.person[id],"155000000Your ally has left!")
		as.ally.person[id]=0
	end
	if #as.popup.image[id]~=0 then
		freeimage(as.popup.image[id][1])
		freeimage(as.popup.image[id][2])
		for i=1,7 do
			parse("hudtxt2 "..id.." "..as.idtable[i].." \"\" 0 0 0")
		end
		as.popup.image[id]={}
		as.busy[as.popup.text[id][1]]=0
		as.popup.text[id]={}
	end
	if #as.popup.queue[id]~=0 then
		parse("hudtxt2 "..id.." "..as.idtable[8].." \"\" 0 0 0")
		as.popup.queue[id]={}
	end
	as.nemesis.count[id]=array(32,0)
	for p=1,#player(0,"table") do
		if player(player(0,"table")[p],"exists") and as.nemesis.person[player(0,"table")[p]]==id then
			if as.nemesis.image[id]~=0 then
				freeimage(as.nemesis.image[id])
				as.nemesis.image[id]=0
			end 
			as.nemesis.count[player(0,"table")[p]][id]=0
			as.nemesis.deaths[player(0,"table")[p]]=0
			msg2(player(0,"table")[p],"000155000Your nemesis has left!")
		end
	end
	as.nemesis.deaths[id]=0
	as.nemesis.person[id]=0
	if as.nemesis.image[id]~=0 then
		freeimage(as.nemesis.image[id])
		as.nemesis.image[id]=0
	end
	as.placeh[id]=0
end

addhook("startround","as.startround")
function as.startround()
	local id=0
	for i=1,#player(0,"table") do
		if player(i,"exists") then
			id=player(0,"table")[i]
			if as.ally.person[id]~=0 then
				as.ally.image[id]=0
				as.ally.image[id]=image("gfx/hud/ally.png",0,0,200+as.ally.person[id],id)
			end
			if #as.popup.image[id]~=0 then
				as.popup.image[id]={}
				if as.popup.text[id][2]=="wants to be your ally!" then
					as.popup.image[id]={image("gfx/hud/square_trans.png",as.popups.subcontents[3][3],as.popups.subcontents[3][4],2,id),image("gfx/hud/overl_full.png",as.popups.subcontents[3][3],as.popups.subcontents[3][4],2,id)}
				else
					as.popup.image[id]={image("gfx/hud/square_trans.png",as.popups.subcontents[1][3],as.popups.subcontents[1][4],2,id),image("gfx/hud/overl_full.png",as.popups.subcontents[1][3],as.popups.subcontents[1][4],2,id)}
				end
			end
			if as.nemesis.image[id]~=0 then
				as.nemesis.image[id]=0
				as.nemesis.image[id]=image("gfx/hud/nemesis.png",0,0,200+as.nemesis.person[id],id)
			end
		end
	end
end

addhook("say","as.say")
addhook("sayteam","as.say")
function as.say(id,t)
	if t:sub(1,1)==as.chatstring and as.ally.person[id]~=0 then
		msg2(id,"255000255"..player(id,"name").." (Ally Chat): "..t:sub(2))
		msg2(as.ally.person[id],"255000255"..player(id,"name").." (Ally Chat): "..t:sub(2))
		return 1
	end
end

addhook("move","as.move")
function as.move(id,x,y)
	if as.ally.person[id]~=0 and as.ally.teamwork[id]~=0 then
		parse("setpos "..as.ally.person[id].." "..x.." "..y.."")
	end
end
sethookstate("move",0)